package java.util;

import java.time.Instant;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import sun.util.calendar.CalendarSystem;
import sun.util.calendar.ZoneInfo;
import java.text.DateFormat;
import sun.util.calendar.CalendarUtils;
import sun.util.calendar.BaseCalendar;
import java.io.Serializable;

public class Date implements Serializable, Cloneable, Comparable<Date>
{
    private static final BaseCalendar gcal;
    private static BaseCalendar jcal;
    private transient long fastTime;
    private transient BaseCalendar.Date cdate;
    private static int defaultCenturyStart;
    private static final long serialVersionUID = 7523967970034938905L;
    private static final String[] wtb;
    private static final int[] ttb;
    
    public Date() {
        this(System.currentTimeMillis());
    }
    
    public Date(long fastTime) {
        this.fastTime = fastTime;
    }
    
    @Deprecated
    public Date(int n, int n2, int n3) {
        this(n, n2, n3, 0, 0, 0);
    }
    
    @Deprecated
    public Date(int n, int n2, int n3, int n4, int n5) {
        this(n, n2, n3, n4, n5, 0);
    }
    
    @Deprecated
    public Date(int n, int mod, int dayOfMonth, int hours, int minutes, int seconds) {
        int normalizedYear = n + 1900;
        if (mod >= 12) {
            normalizedYear += mod / 12;
            mod %= 12;
        }
        else if (mod < 0) {
            normalizedYear += CalendarUtils.floorDivide(mod, 12);
            mod = CalendarUtils.mod(mod, 12);
        }
        this.cdate = (BaseCalendar.Date)getCalendarSystem(normalizedYear).newCalendarDate(TimeZone.getDefaultRef());
        this.cdate.setNormalizedDate(normalizedYear, mod + 1, dayOfMonth).setTimeOfDay(hours, minutes, seconds, 0);
        this.getTimeImpl();
        this.cdate = null;
    }
    
    @Deprecated
    public Date(String s) {
        this(parse(s));
    }
    
    public Object clone() {
        Date date = null;
        try {
            date = (Date)super.clone();
            if (this.cdate != null) {
                date.cdate = (BaseCalendar.Date)this.cdate.clone();
            }
        }
        catch (CloneNotSupportedException ex) {}
        return date;
    }
    
    @Deprecated
    public static long UTC(int n, int mod, int dayOfMonth, int hours, int minutes, int seconds) {
        int normalizedYear = n + 1900;
        if (mod >= 12) {
            normalizedYear += mod / 12;
            mod %= 12;
        }
        else if (mod < 0) {
            normalizedYear += CalendarUtils.floorDivide(mod, 12);
            mod = CalendarUtils.mod(mod, 12);
        }
        int month = mod + 1;
        BaseCalendar.Date date = (BaseCalendar.Date)getCalendarSystem(normalizedYear).newCalendarDate(null);
        date.setNormalizedDate(normalizedYear, month, dayOfMonth).setTimeOfDay(hours, minutes, seconds, 0);
        Date o = new Date(0L);
        o.normalize(date);
        return o.fastTime;
    }
    
    @Deprecated
    public static long parse(String other) {
        int n = Integer.MIN_VALUE;
        int n2 = -1;
        int n3 = -1;
        int n4 = -1;
        int n5 = -1;
        int n6 = -1;
        int i = 0;
        int n7 = -1;
        int n8 = 0;
        if (other != null) {
            int length = other.length();
            while (i < length) {
                int n9 = other.charAt(i);
                ++i;
                if (n9 <= ' ') {
                    continue;
                }
                if (n9 == ',') {
                    continue;
                }
                if (n9 == '(') {
                    int n13 = 1;
                    while (i < length) {
                        int char2 = other.charAt(i);
                        ++i;
                        if (char2 == '(') {
                            ++n13;
                        }
                        else {
                            if (char2 != ')' || --n13 > 0) {
                                continue;
                            }
                            break;
                        }
                    }
                }
                else if ('0' <= n9 && n9 <= '9') {
                    int n11 = n9 - 48;
                    while (i < length && '0' <= (n9 = other.charAt(i)) && n9 <= '9') {
                        n11 = n11 * 10 + n9 - 48;
                        ++i;
                    }
                    if (n8 == 43 || (n8 == 45 && n != Integer.MIN_VALUE)) {
                        int n12;
                        if (n11 < 24) {
                            n12 = n11 * 60;
                        }
                        else {
                            n12 = n11 % 100 + n11 / 100 * 60;
                        }
                        if (n8 == 43) {
                            n12 = -n12;
                        }
                        if (n7 != 0 && n7 != -1) {
                            throw new IllegalArgumentException();
                        }
                        n7 = n12;
                    }
                    else if (n11 >= 70) {
                        if (n != Integer.MIN_VALUE) {
                            throw new IllegalArgumentException();
                        }
                        if (n9 <= ' ' || n9 == ',' || n9 == '/' || i >= length) {
                            n = n11;
                        }
                        else {
                            throw new IllegalArgumentException();
                        }
                    }
                    else if (n9 == ':') {
                        if (n4 < 0) {
                            n4 = (byte)n11;
                        }
                        else if (n5 < 0) {
                            n5 = (byte)n11;
                        }
                        else {
                            throw new IllegalArgumentException();
                        }
                    }
                    else if (n9 == '/') {
                        if (n2 < 0) {
                            n2 = (byte)(n11 - 1);
                        }
                        else if (n3 < 0) {
                            n3 = (byte)n11;
                        }
                        else {
                            throw new IllegalArgumentException();
                        }
                    }
                    else {
                        if (i < length && n9 != ',' && n9 > ' ' && n9 != '-') {
                            throw new IllegalArgumentException();
                        }
                        if (n4 >= 0 && n5 < 0) {
                            n5 = (byte)n11;
                        }
                        else if (n5 >= 0 && n6 < 0) {
                            n6 = (byte)n11;
                        }
                        else if (n3 < 0) {
                            n3 = (byte)n11;
                        }
                        else if (n == Integer.MIN_VALUE && n2 >= 0 && n3 >= 0) {
                            n = n11;
                        }
                        else {
                            throw new IllegalArgumentException();
                        }
                    }
                    n8 = 0;
                }
                else if (n9 == '/' || n9 == ':' || n9 == '+' || n9 == '-') {
                    n8 = n9;
                }
                else {
                    int ooffset = i - 1;
                    while (i < length) {
                        int char1 = other.charAt(i);
                        if ('A' > char1 || char1 > 'Z') {
                            if ('a' <= char1) {
                                if (char1 > 'z') {
                                    break;
                                }
                            }
                            else {
                                break;
                            }
                        }
                        ++i;
                    }
                    if (i <= ooffset + 1) {
                        throw new IllegalArgumentException();
                    }
                    int length2 = Date.wtb.length;
                    while (--length2 >= 0) {
                        if (!Date.wtb[length2].regionMatches(true, 0, other, ooffset, i - ooffset)) {
                            continue;
                        }
                        int n10 = Date.ttb[length2];
                        if (n10 != 0) {
                            if (n10 == 1) {
                                if (n4 <= 12) {
                                    if (n4 < 1) {
                                        throw new IllegalArgumentException();
                                    }
                                    if (n4 < 12) {
                                        n4 += 12;
                                        break;
                                    }
                                    break;
                                }
                                else {
                                    throw new IllegalArgumentException();
                                }
                            }
                            else if (n10 == 14) {
                                if (n4 <= 12) {
                                    if (n4 < 1) {
                                        throw new IllegalArgumentException();
                                    }
                                    if (n4 == 12) {
                                        n4 = 0;
                                        break;
                                    }
                                    break;
                                }
                                else {
                                    throw new IllegalArgumentException();
                                }
                            }
                            else if (n10 <= 13) {
                                if (n2 < 0) {
                                    n2 = (byte)(n10 - 2);
                                    break;
                                }
                                throw new IllegalArgumentException();
                            }
                            else {
                                n7 = n10 - 10000;
                                break;
                            }
                        }
                        else {
                            break;
                        }
                    }
                    if (length2 < 0) {
                        throw new IllegalArgumentException();
                    }
                    n8 = 0;
                }
            }
            if (n != Integer.MIN_VALUE && n2 >= 0 && n3 >= 0) {
                if (n < 100) {
                    synchronized (Date.class) {
                        if (Date.defaultCenturyStart == 0) {
                            Date.defaultCenturyStart = Date.gcal.getCalendarDate().getYear() - 80;
                        }
                    }
                    n += Date.defaultCenturyStart / 100 * 100;
                    if (n < Date.defaultCenturyStart) {
                        n += 100;
                    }
                }
                if (n6 < 0) {
                    n6 = 0;
                }
                if (n5 < 0) {
                    n5 = 0;
                }
                if (n4 < 0) {
                    n4 = 0;
                }
                BaseCalendar calendarSystem = getCalendarSystem(n);
                if (n7 == -1) {
                    BaseCalendar.Date date2 = (BaseCalendar.Date)calendarSystem.newCalendarDate(TimeZone.getDefaultRef());
                    date2.setDate(n, n2 + 1, n3);
                    date2.setTimeOfDay(n4, n5, n6, 0);
                    return calendarSystem.getTime(date2);
                }
                BaseCalendar.Date date = (BaseCalendar.Date)calendarSystem.newCalendarDate(null);
                date.setDate(n, n2 + 1, n3);
                date.setTimeOfDay(n4, n5, n6, 0);
                return calendarSystem.getTime(date) + (long)(n7 * 60000);
            }
        }
        throw new IllegalArgumentException();
    }
    
    @Deprecated
    public int getYear() {
        return this.normalize().getYear() - 1900;
    }
    
    @Deprecated
    public void setYear(int n) {
        this.getCalendarDate().setNormalizedYear(n + 1900);
    }
    
    @Deprecated
    public int getMonth() {
        return this.normalize().getMonth() - 1;
    }
    
    @Deprecated
    public void setMonth(int mod) {
        int floorDivide = 0;
        if (mod >= 12) {
            floorDivide = mod / 12;
            mod %= 12;
        }
        else if (mod < 0) {
            floorDivide = CalendarUtils.floorDivide(mod, 12);
            mod = CalendarUtils.mod(mod, 12);
        }
        BaseCalendar.Date calendarDate = this.getCalendarDate();
        if (floorDivide != 0) {
            calendarDate.setNormalizedYear(calendarDate.getNormalizedYear() + floorDivide);
        }
        calendarDate.setMonth(mod + 1);
    }
    
    @Deprecated
    public int getDate() {
        return this.normalize().getDayOfMonth();
    }
    
    @Deprecated
    public void setDate(int dayOfMonth) {
        this.getCalendarDate().setDayOfMonth(dayOfMonth);
    }
    
    @Deprecated
    public int getDay() {
        return this.normalize().getDayOfWeek() - 1;
    }
    
    @Deprecated
    public int getHours() {
        return this.normalize().getHours();
    }
    
    @Deprecated
    public void setHours(int hours) {
        this.getCalendarDate().setHours(hours);
    }
    
    @Deprecated
    public int getMinutes() {
        return this.normalize().getMinutes();
    }
    
    @Deprecated
    public void setMinutes(int minutes) {
        this.getCalendarDate().setMinutes(minutes);
    }
    
    @Deprecated
    public int getSeconds() {
        return this.normalize().getSeconds();
    }
    
    @Deprecated
    public void setSeconds(int seconds) {
        this.getCalendarDate().setSeconds(seconds);
    }
    
    public long getTime() {
        return this.getTimeImpl();
    }
    
    private final long getTimeImpl() {
        if (this.cdate != null && !this.cdate.isNormalized()) {
            this.normalize();
        }
        return this.fastTime;
    }
    
    public void setTime(long fastTime) {
        this.fastTime = fastTime;
        this.cdate = null;
    }
    
    public boolean before(Date date) {
        return getMillisOf(this) < getMillisOf(date);
    }
    
    public boolean after(Date date) {
        return getMillisOf(this) > getMillisOf(date);
    }
    
    @Override
    public boolean equals(Object o) {
        return o instanceof Date && this.getTime() == ((Date)o).getTime();
    }
    
    static final long getMillisOf(Date date) {
        if (date.cdate == null || date.cdate.isNormalized()) {
            return date.fastTime;
        }
        return Date.gcal.getTime((BaseCalendar.Date)date.cdate.clone());
    }
    
    @Override
    public int compareTo(Date date) {
        long millis = getMillisOf(this);
        long millis2 = getMillisOf(date);
        return (millis < millis2) ? -1 : ((millis == millis2) ? false : true);
    }
    
    @Override
    public int hashCode() {
        long time = this.getTime();
        return (int)time ^ (int)(time >> 32);
    }
    
    @Override
    public String toString() {
        BaseCalendar.Date normalize = this.normalize();
        StringBuilder sb = new StringBuilder(28);
        int dayOfWeek = normalize.getDayOfWeek();
        if (dayOfWeek == 1) {
            dayOfWeek = 8;
        }
        convertToAbbr(sb, Date.wtb[dayOfWeek]).append(' ');
        convertToAbbr(sb, Date.wtb[normalize.getMonth() - 1 + 2 + 7]).append(' ');
        CalendarUtils.sprintf0d(sb, normalize.getDayOfMonth(), 2).append(' ');
        CalendarUtils.sprintf0d(sb, normalize.getHours(), 2).append(':');
        CalendarUtils.sprintf0d(sb, normalize.getMinutes(), 2).append(':');
        CalendarUtils.sprintf0d(sb, normalize.getSeconds(), 2).append(' ');
        TimeZone zone = normalize.getZone();
        if (zone != null) {
            sb.append(zone.getDisplayName(normalize.isDaylightTime(), 0, Locale.US));
        }
        else {
            sb.append("GMT");
        }
        sb.append(' ').append(normalize.getYear());
        return sb.toString();
    }
    
    private static final StringBuilder convertToAbbr(StringBuilder sb, String s) {
        sb.append(Character.toUpperCase(s.charAt(0)));
        sb.append(s.charAt(1)).append(s.charAt(2));
        return sb;
    }
    
    @Deprecated
    public String toLocaleString() {
        return DateFormat.getDateTimeInstance().format(this);
    }
    
    @Deprecated
    public String toGMTString() {
        BaseCalendar.Date date = (BaseCalendar.Date)getCalendarSystem(this.getTime()).getCalendarDate(this.getTime(), (TimeZone)null);
        StringBuilder sb = new StringBuilder(32);
        CalendarUtils.sprintf0d(sb, date.getDayOfMonth(), 1).append(' ');
        convertToAbbr(sb, Date.wtb[date.getMonth() - 1 + 2 + 7]).append(' ');
        sb.append(date.getYear()).append(' ');
        CalendarUtils.sprintf0d(sb, date.getHours(), 2).append(':');
        CalendarUtils.sprintf0d(sb, date.getMinutes(), 2).append(':');
        CalendarUtils.sprintf0d(sb, date.getSeconds(), 2);
        sb.append(" GMT");
        return sb.toString();
    }
    
    @Deprecated
    public int getTimezoneOffset() {
        int n;
        if (this.cdate == null) {
            TimeZone defaultRef = TimeZone.getDefaultRef();
            if ((defaultRef instanceof ZoneInfo)) {
                n = ((ZoneInfo)defaultRef).getOffsets(this.fastTime, (int[])null);
            }
            else {
                n = defaultRef.getOffset(this.fastTime);
            }
        }
        else {
            this.normalize();
            n = this.cdate.getZoneOffset();
        }
        return -n / 60000;
    }
    
    private final BaseCalendar.Date getCalendarDate() {
        if (this.cdate == null) {
            this.cdate = (BaseCalendar.Date)getCalendarSystem(this.fastTime).getCalendarDate(this.fastTime, TimeZone.getDefaultRef());
        }
        return this.cdate;
    }
    
    private final BaseCalendar.Date normalize() {
        if (this.cdate == null) {
            return this.cdate = (BaseCalendar.Date)getCalendarSystem(this.fastTime).getCalendarDate(this.fastTime, TimeZone.getDefaultRef());
        }
        if (!this.cdate.isNormalized()) {
            this.cdate = this.normalize(this.cdate);
        }
        TimeZone defaultRef = TimeZone.getDefaultRef();
        if (defaultRef != this.cdate.getZone()) {
            this.cdate.setZone(defaultRef);
            getCalendarSystem(this.cdate).getCalendarDate(this.fastTime, this.cdate);
        }
        return this.cdate;
    }
    
    private final BaseCalendar.Date normalize(BaseCalendar.Date date) {
        int normalizedYear = date.getNormalizedYear();
        int month = date.getMonth();
        int dayOfMonth = date.getDayOfMonth();
        int hours = date.getHours();
        int minutes = date.getMinutes();
        int seconds = date.getSeconds();
        int millis = date.getMillis();
        TimeZone zone = date.getZone();
        if (normalizedYear == 1582 || normalizedYear > 280000000 || normalizedYear < -280000000) {
            if (zone == null) {
                zone = TimeZone.getTimeZone("GMT");
            }
            GregorianCalendar o = new GregorianCalendar(zone);
            o.clear();
            o.set(14, millis);
            o.set(normalizedYear, month - 1, dayOfMonth, hours, minutes, seconds);
            this.fastTime = o.getTimeInMillis();
            date = (BaseCalendar.Date)getCalendarSystem(this.fastTime).getCalendarDate(this.fastTime, zone);
            return date;
        }
        else {
            BaseCalendar calendarSystem = getCalendarSystem(normalizedYear);
            if (calendarSystem != getCalendarSystem(date)) {
                date = (BaseCalendar.Date)calendarSystem.newCalendarDate(zone);
                date.setNormalizedDate(normalizedYear, month, dayOfMonth).setTimeOfDay(hours, minutes, seconds, millis);
            }
            this.fastTime = calendarSystem.getTime(date);
            BaseCalendar calendarSystem2 = getCalendarSystem(this.fastTime);
            if (calendarSystem2 != calendarSystem) {
                date = (BaseCalendar.Date)calendarSystem2.newCalendarDate(zone);
                date.setNormalizedDate(normalizedYear, month, dayOfMonth).setTimeOfDay(hours, minutes, seconds, millis);
                this.fastTime = calendarSystem2.getTime(date);
                return date;
            }
            return date;
        }
    }
    
    private static final BaseCalendar getCalendarSystem(int n) {
        if (n >= 1582) {
            return Date.gcal;
        }
        return getJulianCalendar();
    }
    
    private static final BaseCalendar getCalendarSystem(long n) {
        if (n >= 0L || n >= -12219292800000L - (long)TimeZone.getDefaultRef().getOffset(n)) {
            return Date.gcal;
        }
        return getJulianCalendar();
    }
    
    private static final BaseCalendar getCalendarSystem(BaseCalendar.Date date) {
        if (Date.jcal == null) {
            return Date.gcal;
        }
        if (date.getEra() != null) {
            return Date.jcal;
        }
        return Date.gcal;
    }
    
    private static final synchronized BaseCalendar getJulianCalendar() {
        if (Date.jcal == null) {
            Date.jcal = (BaseCalendar)CalendarSystem.forName("julian");
        }
        return Date.jcal;
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        objectOutputStream.writeLong(this.getTimeImpl());
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        this.fastTime = objectInputStream.readLong();
    }
    
    public static Date from(Instant instant) {
        try {
            return new Date(instant.toEpochMilli());
        }
        catch (ArithmeticException cause) {
            throw new IllegalArgumentException(cause);
        }
    }
    
    public Instant toInstant() {
        return Instant.ofEpochMilli(this.getTime());
    }
    
    static {
        gcal = CalendarSystem.getGregorianCalendar();
        wtb = new String[] { "am", "pm", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "sunday", "january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december", "gmt", "ut", "utc", "est", "edt", "cst", "cdt", "mst", "mdt", "pst", "pdt" };
        ttb = new int[] { 14, 1, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 10000, 10000, 10000, 10300, 10240, 10360, 10300, 10420, 10360, 10480, 10420 };
    }
}
